use Test2::V0;

package Foo {
    sub doit { 'A' }
}
{
    my $mock = mock 'Foo' => (override => [doit => sub { 'B' }],);
    is +Foo->doit, 'B', '書き換えられた';
}
is +Foo->doit, 'A', 'スコープを抜けると元のメソッドが呼ばれている';

my $mock = mock 'Foo' => (
    before => [doit => sub { warn 'before' }],
    after  => [doit => sub { warn 'after' }],
    around => [
        doit => sub {
            warn 'around';

            # 元のメソッドのコードリファレンス
            my $orig = shift;

            # メソッドの引数
            my (@args) = @_;

            # 元のメソッドを実行した結果
            return $orig->(@args);
        }
    ],
);
Foo->doit('foo');

done_testing;
